%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list)

global ErrCode;

global DB_ELEMENTS;
global AST_NODES;

global AT_ELEMENTS;
global AT_NODES;

Element_list = unique(Element_list);

% Проверка размерности массивов узлов
if (size(Node_list,1) ~= size(Target_Node_list,1))
    fprintf (1, '\nОшибка функции DB_Elm_Modify_Conn: несовпадающие размерности массивов узлов !\n');
    ErrCode = -1;
    return;
end

% Проверка уникальности массивов узлов
if (size(Node_list,1) ~= size(unique(Node_list),1))
    fprintf (1, '\nОшибка функции DB_Elm_Modify_Conn: совпадающие номера узлов в исходном массиве узлов !\n');
    ErrCode = -1;
    return;
end
if (size(Target_Node_list,1) ~= size(unique(Target_Node_list),1))
    fprintf (1, '\nОшибка функции DB_Elm_Modify_Conn: совпадающие номера узлов в целевом массиве узлов !\n');
    ErrCode = -1;
    return;
end

% Проверка существования в базе элементов
for i=1:size(Element_list,1)
    if (~DB_Elm_Exist(Element_list(i)))
        fprintf (1, '\nОшибка функции DB_Elm_Modify_Conn: элемент с номером %i отсутствует в базе !\n', Element_list(i));
        ErrCode = -1;
        return;
    end
end

% Проверка существования в базе исходных узлов
for i=1:size(Node_list,1)
    if (~DB_Node_Exist(Node_list(i)))
        fprintf (1, '\nОшибка функции DB_Elm_Modify_Conn: узел с номером %i отсутствует в базе !\n', Node_list(i));
        ErrCode = -1;
        return;
    end
end

% Проверка существования в базе новых узлов
for i=1:size(Target_Node_list,1)
    if (~DB_Node_Exist(Target_Node_list(i)))
        fprintf (1, '\nОшибка функции DB_Elm_Modify_Conn: узел с номером %i отсутствует в базе !\n', Target_Node_list(i));
        ErrCode = -1;
        return;
    end
end

% Цикл по массиву элементов
for i=1:size(Element_list,1)
    
    Change_flag = 0;
    
    % Цикл по узлам элемента
    for j=1:DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.N_nodes
        
        % Проверка узла
        [member_flag,location] = ismember(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes(j), Node_list);
        
        if (member_flag)
            
            % Внесение изменений в таблицу ассоциативности узлов (удаление элемента)
            AST_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes(j))}.Elm_list = setdiff(AST_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes(j))}.Elm_list, Element_list(i));
            if (isempty(AST_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes(j))}.Elm_list))
                AST_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes(j))}.Elm_list = [];
            end
            
            % Замена узла
            DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes(j) = Target_Node_list(location);
            
            % Установка флага
            Change_flag = 1;
            
        end
        
    end
    
    % Внесение изменений в таблицу ассоциативности узлов (добавление элемента)
    if (Change_flag == 1)
        for j=1:DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.N_nodes
            AST_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes(j))}.Elm_list = Union_Column(AST_NODES{AT_NODES(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes(j))}.Elm_list, Element_list(i));
        end
    end
    
    % Проверка элемента на совпадающие узлы
    if (Change_flag == 1)
        if (size(unique(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes)) ~= DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.N_nodes)
            fprintf (1, '\nОшибка функции DB_Elm_Modify_Conn: замена узлов привела к появлению совпадающих узлов в элементе %i !\n', Element_list(i));
            ErrCode = -1;
            return;
        end
    end
    
end
